import 'package:example/employee/employee.model.dart';
import 'package:example/employee/employee_form.page.dart';
import 'package:example/employee/employee_list.page.dart';
import 'package:flutter/material.dart';
import 'package:tecfy_basic_package/tecfy_basic_package.dart';

class EmployeeController extends TecfyController {
  late List<Employee> employees;
  late List<Employee> employeesAfterSearch;
  Employee? selectedEmployee;
  // ValueNotifier<int> length = ValueNotifier<int>(0);
  TextEditingController? employeeName;
  TextEditingController? searchText;

  @override
  void init(Widget page) {
    if (page is EmployeeListPage) {
      searchText = TextEditingController();
      searchText?.addListener(() {
        employeesAfterSearch = employees
            .where((e) => e.displayName.contains(searchText!.text))
            .toList();
        setState();
      });
      employees = [];
      for (var i = 0; i < 100; i++) {
        employees.add(Employee(id: '$i', name: 'Default $i'));
      }
      employeesAfterSearch = employees.toList();
    } else if (page is EmployeeFormPage) {
      employeeName = TextEditingController();
    }
  }

  @override
  void dispose(Widget page) {
    if (page is EmployeeListPage) {
      searchText?.dispose();
    } else if (page is EmployeeFormPage) {
      employeeName?.dispose();
    }
    super.dispose(page);
  }

  @override
  Future initLate(Widget page) async {}

  onOpenNewEmployeePage() async {
    setStateAll(() {});
    selectedEmployee = Employee();
    AppNavigator.navigateTo(context, () => EmployeeFormPage(controller: this));
  }

  void addEmployee() {
    employees.add(Employee(
        id: '${employees.length + 1}', name: employeeName?.text ?? ''));
    //setStateById("EmployeeListPage", () {}); //or
    setStateAll(() {});
    AppNavigator.pop(context);
  }
}
