import 'package:example/employee/employee.controller.dart';
import 'package:flutter/material.dart';
import 'package:tecfy_basic_package/tecfy_basic_package.dart';

class EmployeeListPage extends TecfyStatefulWidget<EmployeeController> {
  EmployeeListPage({Key? key, EmployeeController? controller})
      : super(controller, key: key);

  @override
  _EmployeeListPageState createState() => _EmployeeListPageState();

  @override
  TecfyBeamerPageRoute? beamer() {
    return TecfyBeamerPageRoute('/employees',
        (p0, p1, p2) => BeamerService.beamPageEx(child: EmployeeListPage()));
  }
}

class _EmployeeListPageState
    extends TecfyState<EmployeeListPage, EmployeeController>
    with SingleTickerProviderStateMixin {
  @override
  EmployeeController createController() => EmployeeController();

  late TabController tabController;

  @override
  void initState() {
    tabController = TabController(length: 2, vsync: this);
    super.initState();
  }

  var scrollC = ScrollController();
  @override
  Widget build(BuildContext context) {
    // return NestedScrollViewExample();
    return TecfyMobileScaffold(
      controller: scrollC,
      sliverAppBar: SliverAppBar(
        expandedHeight: 100,
        floating: true,
        flexibleSpace: Container(
          color: Colors.yellow,
        ),
      ),
      headers: [
        TecfyHeader.fixed(
            pinned: true,
            child: Container(
              color: Colors.red,
              child: TabBar(
                  controller: tabController,
                  tabs: [Tab(text: 'tab1'), Tab(text: 'tab2')]),
            ),
            height: 40)
      ],
      tabBarViewBody: TabBarView(
        controller: tabController,
        children: [
          CustomScrollView(
            slivers: <Widget>[
              SliverList.builder(
                itemBuilder: (context, index) => Padding(
                  padding: const EdgeInsets.all(8.0),
                  child: Container(
                    child: Center(child: Text(index.toString())),
                    height: 50,
                    color: Colors.red,
                  ),
                ),
                itemCount: 30,
              )
            ],
          ),
          ListView.builder(
            itemBuilder: (context, index) => Padding(
              padding: const EdgeInsets.all(8.0),
              child: Container(
                child: Center(child: Text(index.toString())),
                height: 50,
                color: Colors.blue,
              ),
            ),
            itemCount: 30,
          )
        ],
      ),
    );

    // return  Scaffold(
    //

    //   body: ListView.builder(
    //     itemCount: controller.employees.length,
    //     itemBuilder: (c, i) => ListTile(
    //       title: Text(controller.employees[i].displayName),
    //       trailing: Text(controller.employees[i].idValue),
    //     ),
    //   ),
    // );
  }
}

class NestedScrollViewExample extends StatelessWidget {
  const NestedScrollViewExample({super.key});

  @override
  Widget build(BuildContext context) {
    final List<String> tabs = <String>['Tab 1', 'Tab 2'];
    return DefaultTabController(
      length: tabs.length, // This is the number of tabs.
      child: Scaffold(
        body: NestedScrollView(
          headerSliverBuilder: (BuildContext context, bool innerBoxIsScrolled) {
            // These are the slivers that show up in the "outer" scroll view.
            return <Widget>[
              SliverOverlapAbsorber(
                // This widget takes the overlapping behavior of the SliverAppBar,
                // and redirects it to the SliverOverlapInjector below. If it is
                // missing, then it is possible for the nested "inner" scroll view
                // below to end up under the SliverAppBar even when the inner
                // scroll view thinks it has not been scrolled.
                // This is not necessary if the "headerSliverBuilder" only builds
                // widgets that do not overlap the next sliver.
                handle:
                    NestedScrollView.sliverOverlapAbsorberHandleFor(context),
                sliver: SliverAppBar(
                  title:
                      const Text('Books'), // This is the title in the app bar.
                  floating: true,
                  expandedHeight: 150.0,
                  // The "forceElevated" property causes the SliverAppBar to show
                  // a shadow. The "innerBoxIsScrolled" parameter is true when the
                  // inner scroll view is scrolled beyond its "zero" point, i.e.
                  // when it appears to be scrolled below the SliverAppBar.
                  // Without this, there are cases where the shadow would appear
                  // or not appear inappropriately, because the SliverAppBar is
                  // not actually aware of the precise position of the inner
                  // scroll views.
                  forceElevated: innerBoxIsScrolled,
                  bottom: TabBar(
                    // These are the widgets to put in each tab in the tab bar.
                    tabs: tabs.map((String name) => Tab(text: name)).toList(),
                  ),
                ),
              ),
            ];
          },
          body: TabBarView(
            // These are the contents of the tab views, below the tabs.
            children: tabs.map((String name) {
              return SafeArea(
                top: false,
                bottom: false,
                child: Builder(
                  // This Builder is needed to provide a BuildContext that is
                  // "inside" the NestedScrollView, so that
                  // sliverOverlapAbsorberHandleFor() can find the
                  // NestedScrollView.
                  builder: (BuildContext context) {
                    return CustomScrollView(
                      // The "controller" and "primary" members should be left
                      // unset, so that the NestedScrollView can control this
                      // inner scroll view.
                      // If the "controller" property is set, then this scroll
                      // view will not be associated with the NestedScrollView.
                      // The PageStorageKey should be unique to this ScrollView;
                      // it allows the list to remember its scroll position when
                      // the tab view is not on the screen.
                      key: PageStorageKey<String>(name),
                      slivers: <Widget>[
                        SliverOverlapInjector(
                          // This is the flip side of the SliverOverlapAbsorber
                          // above.
                          handle:
                              NestedScrollView.sliverOverlapAbsorberHandleFor(
                                  context),
                        ),
                        SliverPadding(
                          padding: const EdgeInsets.all(8.0),
                          // In this example, the inner scroll view has
                          // fixed-height list items, hence the use of
                          // SliverFixedExtentList. However, one could use any
                          // sliver widget here, e.g. SliverList or SliverGrid.
                          sliver: SliverFixedExtentList(
                            // The items in this example are fixed to 48 pixels
                            // high. This matches the Material Design spec for
                            // ListTile widgets.
                            itemExtent: 48.0,
                            delegate: SliverChildBuilderDelegate(
                              (BuildContext context, int index) {
                                // This builder is called for each child.
                                // In this example, we just number each list item.
                                return ListTile(
                                  title: Text('Item $index'),
                                );
                              },
                              // The childCount of the SliverChildBuilderDelegate
                              // specifies how many children this inner list
                              // has. In this example, each tab has a list of
                              // exactly 30 items, but this is arbitrary.
                              childCount: 50,
                            ),
                          ),
                        ),
                      ],
                    );
                  },
                ),
              );
            }).toList(),
          ),
        ),
      ),
    );
  }
}
