part of tecfy_basic_package;

abstract class TecfyStatefulWidget<C extends TecfyController>
    extends StatefulWidget {
  final C? controller;

  /// you can use this id to refresh/setState the widget by the stateID
  /// when null then use the statefull class name
  final String? stateId;
  TecfyStatefulWidget(this.controller, {Key? key, this.stateId}) {
    if (beamer() != null && BeamerService.routes.containsKey(beamer()!.path)) {
      print('XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX');
      print(
          'XXXXXX you need to register the beamer function in BeamerServer.pages');
      print('XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX');
    }
  }

  TecfyBeamerPageRoute? beamer();
}

abstract class TecfyState<T extends TecfyStatefulWidget,
        C extends TecfyController> extends State<T>
    with LifecycleAware, LifecycleMixin {
  late C controller;

  /// Whether this [State] object is displayed on the screen.
  bool isDislplayed = false;
  Future<void> onDisplayed(Widget page, bool _isDislplayed) async {
    controller.onDisplayed(this.widget, _isDislplayed);
  }

  C createController();

  @override
  void onLifecycleEvent(LifecycleEvent event) {
    if (event == LifecycleEvent.active) {
      controller.state = this;
      isDislplayed = true;
    } else {
      isDislplayed = false;
    }
    onDisplayed(this.widget, isDislplayed);
  }

  @override
  initState() {
    controller = createController();
    controller.setNewState(widget.stateId ?? widget.toString(), this);
    print('${widget.stateId} - Class name ${this.widget.runtimeType}');
    controller.init(this.widget);
    controller.initLate(this.widget).then((value) => controller.setState());
    super.initState();
  }

  @override
  dispose() {
    controller.dispose(this.widget);
    super.dispose();
  }
}
